require 'active_support/all'
require 'resource_kit'
require 'kartograph'

module Processmaker
  autoload :Client, 'processmaker/client'

  # Models
  autoload :BaseModel, 'processmaker/models/base_model'
  autoload :Case, 'processmaker/models/case'
  autoload :Project, 'processmaker/models/project'
  autoload :Activity, 'processmaker/models/activity'
  autoload :User, 'processmaker/models/user'

  # Resources
  autoload :CaseResource, 'processmaker/resources/case_resource'
  autoload :ProjectResource, 'processmaker/resources/project_resource'
  autoload :UserResource, 'processmaker/resources/user_resource'

  # JSON Maps
  autoload :CaseMapping, 'processmaker/mappings/case_mapping'
  autoload :ProjectMapping, 'processmaker/mappings/project_mapping'
  autoload :ActivityMapping, 'processmaker/mappings/activity_mapping'
  autoload :UserMapping, 'processmaker/mappings/user_mapping'

  # Errors
end
