module Processmaker
  class CaseResource < ResourceKit::Resource

    resources do

      default_handler { |response| response }

      # http://wiki.processmaker.com/3.1/REST_API_Cases#Get_To_Do_Cases:_GET_.2Fcases
      action :all, 'GET /cases' do
        path '/api/1.0/workflow/cases'
        verb :get
        body { |object| object }
      end

      # http://wiki.processmaker.com/3.1/REST_API_Cases#New_Case:_POST_.2Fcases
      action :create, 'POST /cases/impersonate' do
        path '/api/1.0/workflow/cases/impersonate'
        verb :post
        body { |object| CaseMapping.representation_for(:create, object) }
        handler(:ok) { |response, object| CaseMapping.extract_into_object(object, response.body, :read)}
      end

      # http://wiki.processmaker.com/3.1/REST_API_Cases#Route_Case:_PUT_.2Fcases.2F.7Bapp_uid.7D.2Froute-case
      action :route do
        path '/api/1.0/workflow/cases/:app_uid/route-case'
        verb :put
        body { |request| request.to_json }
        handler(:ok) { |response, object| CaseMapping.extract_into_object(object, response.body, :read)}
      end
    end


  end
end
