module Processmaker
  class ProjectResource < ResourceKit::Resource

    resources do

      default_handler { |response| response }

      # http://wiki.processmaker.com/3.1/REST_API_Cases#Get_To_Do_Cases:_GET_.2Fcases
      # @return [Array<Processmaker::Project>] a collection of of projects
      action :all, 'GET /projects' do
        path '/api/1.0/workflow/projects'
        verb :get
        handler(:ok) { |response| ProjectMapping.extract_collection(response.body, :read)}
      end

      # http://wiki.processmaker.com/3.0/REST_API_Designer#Get_starting_tasks
      # @param prj_uid [String] the project unique identifier
      # @return [Array<Processmaker::Activity>] A collection of activities
      action :starting_tasks, 'GET /project/:prj_uid/starting-tasks' do
        path '/api/1.0/workflow/project/:prj_uid/starting-tasks'
        verb :get
        handler(:ok) { |response| ActivityMapping.extract_collection(response.body, :read)}
      end
    end
  end
end
