module Processmaker
  class UserResource < ResourceKit::Resource

    resources do

      default_handler { |response| response }

      # http://wiki.processmaker.com/3.1/REST_API_Administration#Get_Users_List:_GET_.2Fusers
      # @return [Array<Processmaker::User>] a collection of of projects
      action :all, 'GET /users' do
        path '/api/1.0/workflow/users'
        query_keys :filter, :start, :limit
        verb :get
        handler(:ok) { |response| UserMapping.extract_collection(response.body, :read) }
      end
    end
  end
end
